import json
import common_utils
import xmltodict
import os
import re
import pathlib
import xml.etree.ElementTree as ET

# import xml.etree.ElementTree as ET
# from xml.dom.minidom import parse


# 报警信息展示
'''
{"action": true, "data": {"sender": "hatest@cs2c.com.cn", "smtp": "mailgw.cs2c.com.cn", "flag": "on", "receiver": ["hatest@cs2c.com.cn", ".com"], "password": "hhaest", "port": "25"}}
'''

def alarms_get():
    data = {}
    cmd_get_alert = "cibadmin --query --scope configuration"
    status, stdout = common_utils.run_cmd(cmd_get_alert)
    json_str = json.dumps(xmltodict.parse(stdout))
    conf_json = json.loads(json_str)['configuration']
    if 'alerts' in conf_json:
        alerts_json = conf_json['alerts']
    else:
        alerts_json = None
    sender = ""
    smtp = ""
    password = ""
    port = ""
    switch = ""
    if alerts_json is not None:
        if 'alert' in alerts_json:
            alert_info = alerts_json['alert']

            # if has value
            recipients = []
            if 'recipient' in alert_info:
                receivers = alert_info['recipient']
                if isinstance(receivers, list):
                    for receiver in receivers:
                        value = receiver['@value']
                        recipients.append(value)
                else:
                    value = receivers['@value']
                    recipients.append(value)

            # If has instance_attributes
            if 'instance_attributes' in alert_info:
                instance_attributes = alert_info['instance_attributes']
                if 'nvpair' in instance_attributes:
                    nvpair = instance_attributes['nvpair']
                    if isinstance(nvpair, list):
                        for value in nvpair:
                            if value['@name'] == 'email_sender':
                                sender = value['@value']
                            if value['@name'] == 'email_server':
                                smtp = value['@value']
                            if value['@name'] == 'password':
                                password = value['@value']
                            if value['@name'] == 'port':
                                port = value['@value']
                            if value['@name'] == 'switch':
                                switch = value['@value']

                        # Get mail password
                        cmdstr = "/usr/bin/pwd_decode " + str(password)
                        status, stdout = common_utils.run_cmd(cmdstr)
                        mail_password = str(stdout)

                        data['sender'] = sender
                        data['smtp'] = smtp
                        data['flag'] = switch
                        data['receiver'] = recipients
                        data['password'] = mail_password
                        data['port'] = port
                    else:
                        data = {}
                        data['flag'] = False
                        data["smtp"] = ""
                        data["port"] = ""
                        data["sender"] = ""
                        data["password"] = ""
                        data["receiver"] = recipients 
    if data == {} or data is None:
        data = {}
        data["flag"] = False
        data["smtp"] = ""
        data["port"] = ""
        data["sender"] = ""
        data["password"] = ""
        data["receiver"] = []

    return ({'action': True, 'data': data})

def alarms_set(data):
    '''
    {'flag': True, 'smtp': 'smtp.com.cn', 'port': '12', 'sender': 'fdsafas@cs2c.com.cn', 'password': 'qwer1234', 'receiver': ['wangyangli@kylinos.cn', 'wangyangli1@kylinos.cn'], 'recipient': []}
    '''
    
    cmd_get_alert = "pcs alert delete alert_Kylin"
    status, stdout = common_utils.run_cmd(cmd_get_alert)

    sender = ""
    smtp = ""
    password = ""
    port = ""
    switch = ""
    if data is not None and data != {}:
        if 'flag' in data:
            if data['flag']:
                switch = "on"
            else:
                switch = "off"
        if 'smtp' in data:
            smtp = str(data['smtp'])
        if 'sender' in data:
            sender = str(data['sender'])
        if 'password' in data:
            cmdstr = "/usr/bin/pwd_encode '" + str(data['password']) + "'"
            status, stdout = common_utils.run_cmd(cmdstr)
            password = str(stdout)
            #password = str(data['password'])
        if 'port' in data:
            port = str(data['port'])
        if 'receiver' in data:
            receiver = data['receiver']
    # Identify reveiver's list
    for recipient in receiver:
         if recipient.strip() == "":
             return {"action": False, "error": _("Receiver email info cannot be empty or space")}

    ops_str = " options email_sender=" + sender +  " email_server=" + smtp +" password=" \
               + password +" port="+ port + " switch=" + switch
    cmd_str = "pcs alert create id=alert_Kylin path=/usr/share/pacemaker/alerts/kylin_alert.sh" + ops_str
    status, stdout = common_utils.run_cmd(cmd_str)
    if status != 0:
        return {"action": False, "error": _("Set alarm failed")}

    for recipient in receiver:
        if recipient.strip() != "":
            reveiver_str = "pcs alert recipient add alert_Kylin" + " value=" + str(recipient) + " --force"
            status, stdout = common_utils.run_cmd(reveiver_str) 
            if status != 0:
                return {"action": False, "error": _("Set alarm failed")}
        else:
            return {"action": False, "error": _("Receiver email info cannot be empty or space")}

    return {"action": True, "info": _("Set alarm success")} 

def alarms_test():
    info = alarms_get()['data']
    sender = info['sender']
    smtp = info['smtp']
    password = info['password']
    port = info['port']
    receiver = info['receiver']
    for recipient in receiver:
        if recipient.strip() != "":
            cmd = "/usr/share/pacemaker/alerts/python_email.py '" + smtp + "' '" + sender + "' '" + password + "' '" + recipient + "' '此邮件为测试邮件' " + port
            status, stdout = common_utils.run_cmd(cmd)
            if status != 0:
                testcmd = "echo send mail to " + recipient + " failed:'" + stdout + "' >>/var/log/mailtest.log"
                os.system(testcmd)
                return {"action": False, "error": _("Set alarm test success failed")}
            else:
                testcmd = "echo send mail to " + recipient + " success >>/var/log/mailtest.log"
                os.system(testcmd)
        else:
            return {"action": False, "error": _("Receiver email info cannot be empty or space")}
    return {"action": True, "info": _("Set alarm test success")}


if __name__ == '__main__':
    print(alarms_get())
