# -*-coding:utf-8-*-
# !/usr/bin/python
# coding: iso-8859-15

import json
import os
import re
import common_utils
import xmltodict
from xml.dom.minidom import parseString
import xml.etree.ElementTree as ET

def list_rule(rscname):
    cmd = "cibadmin --query --scope constraints"
    status, output = common_utils.run_cmd(cmd)
    etree = ET.fromstring(output)
    rules = etree.findall("./rsc_location")
    rulelist = []
    for i in rules:
        if i.get("rsc","") == rscname:
            rule = i.find("rule")
            if rule:
                r = {}
                r["rsc"] = i.get("rsc","")
                r["ruleid"] = rule.get("id","")
                r["score"] =  rule.get("score","")
                exp = rule.find("expression")
                r["attribute"] = exp.get("attribute","")
                r["operation"] = exp.get("operation","")
                r["value"] = exp.get("value","")
                rulelist.append(r)
            else:
                continue
    return rulelist
    
def delete_rule(ruleids):
    ruleidlist = eval(ruleids["ids"])
    res = []
    for ruleid in ruleidlist:
        cmd = "pcs constraint rule delete " + ruleid
        status, output = common_utils.run_cmd(cmd)
        if status != 0:
            res.append({'id':ruleid,'error':output})
    if res == []:
        return {'action': True, 'info':_("Delete rule success!")}
    else:
        return {'action': False, 'error':res}

def add_rule(data):
    if "ruleid" in data:
        cmd = "pcs constraint location "+data["rsc"]+" rule score="+data["score"]+" id="+data["ruleid"]
    else:
        cmd = "pcs constraint location "+data["rsc"]+" rule score="+data["score"]
    if data["value"]:
        cmd = cmd+" "+data["attribute"]+" "+data["operation"]+" "+data["value"]
    else:
        cmd = cmd+" "+data["operation"]+" "+data["attribute"]
    status, output = common_utils.run_cmd(cmd)
    if status != 0:
        return {'action': False, 'error': output}
    else:
        return {'action': True, 'info':_("Add rule success!")}

def update_rule(data):
    cmd = "cibadmin --query --scope constraints"
    status, output = common_utils.run_cmd(cmd)
    etree = ET.fromstring(output)
    rules = etree.findall("./rsc_location/rule")
    r = {}
    for i in rules:
        ruleid = i.get("id","")
        if ruleid == data["ruleid"]:
            r["ruleid"] = ruleid
            r["score"] = i.get("score","")
            exp = i.find("expression")
            r["attribute"] = exp.get("attribute","")
            r["operation"] = exp.get("operation","")
            r["value"] = exp.get("value","")
        else:
            continue
    cmd = "pcs constraint rule delete " + data["ruleid"]
    status, output = common_utils.run_cmd(cmd)
    if status != 0:
        return {'action': False, 'error': output}
    else:
        addres = add_rule(data)
        if 'action' not in addres or not addres['action']:
            add_rule(r)
            return addres
        else:
            return {'action': True, 'info':_("Update rule success!")}
